#!/usr/bin/env python2
#
# GEemyle: WebBrowser module
# Copyright (C) 2003-2006 Easter-eggs <info@easter-eggs.com>
# Authors:
#      Cyril Lacoux (Yack) <clacoux@easter-eggs.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

__author__  = "Cyril Lacoux [Yack] <clacoux@easter-eggs.com>"
__cvsid__   = "$Id$"
__version__ = "$Revision$"[11:-2]
__all__     = ["open_uri", "mail_to", "phone_call", "send_fax"]

import os
import thread
import config
import re
import urllib

import geemyle.eemyle_connector as connector


def open_uri(uri):
    """
    Open an URI
    """
    if not uri:
        return False

    try:
        cmd = '%s >/dev/null 2>&1' % config.get('geemyle', 'browser_command') % uri
    except:
        return False

    thread.start_new_thread(os.system, (cmd, ))
    return True

def mail_to(mail_address):
    """
    Open a mailer
    """
    if not mail_address:
        return False

    try:
        cmd = '%s >/dev/null 2>&1' % config.get('geemyle', 'mail_command') % mail_address
    except:
        return False

    thread.start_new_thread(os.system, (cmd, ))
    return True

def phone_call(phone_number, in_thread=True):
    """
    Start a phone call
    """
    if not phone_number:
        return False

    if in_thread:
        thread.start_new_thread(phone_call, (phone_number, ), {"in_thread": False})
        return True

    connector.init()
    result, _ = connector.eemyle_connector.send_direct_request(
        "phone/call/%s" % urllib.quote(re.sub("[^\+0-9]", "", phone_number))
    )

    return result

def send_fax(fax_number):
    """
    Send a fax
    """
    if not fax_number:
        return False

    try:
        cmd = '%s >/dev/null 2>&1' % config.get('geemyle', 'fax_command') % fax_number
    except:
        return False

    thread.start_new_thread(os.system, (cmd, ))
    return True

